\ job.fs

:m init-serial  m;  \ Done by the bootloader.

\ Choose an interpreter (set in config.fs)
tethered [if] include tether.fs
       [else] include standalone.fs [then]

\ --- Then load the application --- /
include debug.fs	\ Comes before application, useful tools.
include SFR300.fs	\ special function register definitions
include examples.fs
\ include app.fs	\ your application

include interactive.fs  \ Should come _after_ application for efficiency.

\ --- Finally patch the reset vector --- /

\ Turnkey or interactive.
\ start interrupt : cold stacks init-serial go ;
start interrupt : cold stacks init-serial quit ;

tethered [if]  \ For interactive testing, entering numbers.
	:m # number emit-s m;
	:m ## [ dup 8 rshift $ff and swap $ff and ] # # m;
[else]	headers ] here [ dict org heads ##p! org ]
[then]
