\ blinkit.fs   blink dev board LED -- mostly to test bootloader

0 [if]

----- 7Apr07rjn
Blinks the LED attached to P2.1 on the 410
development board.  This is mostly used to test the bootloader.

[then]

] \ target compiler

\ LED I/O
: /led  $02 # P2MDOUT ior! ;
: -led  [ 1 .P2 clr ] ;
: +led  [ 1 .P2 set ] ;
:m ~led  [ 1 .P2 toggle ] m;
: toggle-led  ~led ;

: test  /led  ~led ;

:m once \ once thru the delay & toggle
      7 #for
         0 # 6 #for
            0 # 5 #for  5 #next
         6 #next
      7 #next 
      ~led m;

: blink 	begin once again ;
: blink1    	$04 # blink ;
: blink2    	$07 # blink ;


\ typical usage: /led  $03 # blink
